var package_s = []; //记录当前正在升级的app
var previousPackageName = ''; //上一个升级的包名;
var serverPackageList = []; //记录服务器正在排队的app的所有包名
var _interval = null; //
var currentPackageName = '';

function unas_reposition() {
  return new Promise(function(resolve, reject) {
    jQuery('#systemupgrade_upgrade_waiting_content').attr("style", "display:block");
    jQuery('#systemupgrade_upgrade_waiting_logo').attr("style", "display:block");
    jQuery.ajax({
      url: "/apps/systemupgrade/includes/index.php",
      type: "POST",
      dataType: 'json',
      contentType: "application/json;charset=utf-8",
      data: JSON.stringify({
        "cmd": "unas_reposition",
        "token": UToken
      }),
      success: function(result) {
        resolve(result);
      },
      complete: function(xhr) {

      },
      error: function(xhr, textStatus) {

      }
    })
  })

}

//升级app（只提交请求加入到队列中，不执行后续操作）
function UpgradePkgApply(e, ps) {
  var packagesList = '';
  if (ps != undefined) {
    packagesList = ps;
    package_s = package_s.concat(ps);
  } else {
    packagesList = jQuery(e).attr("pkgname");
    package_s.push(packagesList);
  }
  package_s = Array.from(new Set(package_s));

  jQuery.ajax({
    url: "/apps/systemupgrade/includes/index.php",
    type: "POST",
    timeout: 7200000,
    async: true,
    dataType: 'json',
    data: JSON.encode({
      "cmd": "apps_upgrade",
      "token": UToken,
      "params": {
        "package": packagesList
      }
    }),
    success: function(result) {
      // console.log(result);
      jQuery('#systemupgrade_upgrade_page').css('pointer-events', 'none');
      jQuery('#systemupgrade_upgradable_pkgs_table').css('pointer-events', 'auto');
      jQuery('#systemupgrade_upgradable_pkgs_table tr').css('pointer-events', 'none');
      disableBtn(true);
      let _interval3 = null;
      clearTimeout(_interval3);
      _interval3 = setTimeout(function() {
        checkProgress();
      }, 300);
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      // alert(textStatus);
      jQuery('#systemupgrade_upgrade_waiting_content').attr("style", "display:none");
      jQuery('#systemupgrade_upgrade_waiting_logo').attr("style", "display:none");
      return false;
    }
  });
}

// 检查app下载进度
function checkProgress() {
  jQuery.ajax({
    url: "/apps/systemupgrade/includes/index.php",
    type: "POST",
    // async: true,
    dataType: 'json',
    contentType: "application/json;charset=utf-8",
    data: JSON.encode({
      "cmd": "apps_progress",
      "token": UToken
    }),
    success: function(data) {
      // console.log(data);
      let info = data;
      currentPackageName = currentPackageName || info.results.package;
      serverPackageList = info.results.inslist;
      previousPackageName = package_s[0];
      var pkgname;
      if (info.err == 0) {
        // jQuery('.jvc-' + info.results.package).find('.bar').css('display', 'flex').find('.progressText').text(info.results.progress + '%');

        pkgname = (typeof info.results.package === 'string') ? info.results.package : '';
        pkgname = pkgname.replace('.','');
        jQuery('.jvc-' + pkgname).find('.upgradState').text(UNAS._("Upgrading:"));
        jQuery('.jvc-' + pkgname).find('.progressText').text((info.results.progress || 0) + '%').show();
        jQuery('.jvc-' + pkgname).find('.upgradStateIcon').removeClass('Upgradingimg').addClass('upgradLoading');

        for (var i = 0; i < serverPackageList.length; i++) {
          pkgname = (typeof serverPackageList[i].package === 'string') ? serverPackageList[i].package : '';
          pkgname = pkgname.replace('.','');
          jQuery('.jvc-' + pkgname).find('.upgradState').text(UNAS._("Upgrading:"));
          jQuery('.jvc-' + pkgname).find('.progressText').show();
          jQuery('.jvc-' + pkgname).find('.upgradStateIcon').removeClass('Upgradingimg').addClass('upgradLoading');
        }
        // op == 1 && downloading == 100 && progress >0 : 安装进度(0~100)
        // if (info.results.downloading == 100 && info.results.progress) {
        //   jQuery('.jvc-' + info.results.package).find('.bar').css('display', 'flex').find('.progressText').text(info.results.progress + '%');
        // }

        if (info.results.op == 1) {
          if ((info.results.progress == 100 || previousPackageName != info.results.package) && serverPackageList.length > 1) {
            // console.log(previousPackageName , info.results.package);
            checkAppState(currentPackageName || package_s[0]);
            return;
          }
        } else {
          updateProgress();
          return;
        }

      } else if (info.err == 9994 && serverPackageList.length) {
        for (var i = 0; i < serverPackageList.length; i++) {
          pkgname = (typeof serverPackageList[i].package === 'string') ? serverPackageList[i].package : '';
          pkgname = pkgname.replace('.','');
          jQuery('.jvc-' + pkgname).find('.upgradState').text(UNAS._("Upgrading:"));
          jQuery('.jvc-' + pkgname).find('.progressText').show();
          jQuery('.jvc-' + pkgname).find('.upgradStateIcon').removeClass('Upgradingimg').addClass('upgradLoading');
        }
      }

      if (serverPackageList.length) {
        updateProgress();
      } else {
        clearTimeout(_interval);

        if (Object.keys(info.results).length == 1) {
          checkAppState(package_s[0]);
        }else {
          updateProgress();
        }
      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {


    }
  });
}

//更新进度
function updateProgress() {
  _interval = setTimeout(function() {
    checkProgress();
  }, 2000);
}
var frequency = 1;
// 检查是否完成安装
function checkAppState(packageName) {
  var timeout = null;
  if (!package_s.length) {
    if (frequency) {
      clearTimeout(timeout);
      jQuery('#systemupgrade_upgrade_page').css('pointer-events', 'auto');
      jQuery('#systemupgrade_upgradable_pkgs_table tr').css('pointer-events', 'auto');
      jQuery("#systemupgrade_upgrade_apply").attr("class", "unas_button_content_disabled jvc-sjztbtn");
      disableBtn(false);

      var reloadWindow = new MUI.Modal({
        id: 'reloadWindow',
        title: UNAS._('System Update'),
        contentURL: '/apps/systemupgrade/upgrade_remind.html?v=6.0.73&',
        loadMethod: 'xhr',
        type: 'modal2',
        width: 550,
                height: 250,
                closable: false,
                maximizable: false,
                resizable: false,
                scrollbars: false,
                modalOverlayClose: false,
      });
      reloadWindow.reloadDesktop = function(){
        window.location.reload();
      }

      frequency = 0;
    }
    return;
  } else {
    frequency = 1;
  }

  jQuery.ajax({
    url: "/apps/systemupgrade/includes/index.php",
    type: "POST",
    async: true,
    dataType: 'json',
    contentType: "application/json;charset=utf-8",
    data: JSON.stringify({
      "cmd": "apps_installed",
      "token": UToken,
      "params": {
        "package": packageName
      }
    }),

    success: function(data) {
      let info = data;
      // console.log(info);
      // var packageName = '';
      // if (info.err == 9994) {
      //   packageName = package_s[0];
      // }else {
      //   packageName = info.results.package;
      // }
      previousPackageName = packageName;
      if (package_s.length) {
        pkgname = (typeof packageName === 'string') ? packageName : '';
        pkgname = pkgname.replace('.','');
        jQuery('.jvc-' + pkgname).find('.upgradState').text(UNAS._("Upgrading:"));
        jQuery('.jvc-' + pkgname).find('.progressText').text(100 + '%').show();
        jQuery('.jvc-' + pkgname).find('.upgradStateIcon').removeClass('Upgradingimg').addClass('upgradLoading');
        var r = setTimeout(function() {
          jQuery('.jvc-' + pkgname).remove();
          package_s.remove(packageName);
          currentPackageName = "";
          clearTimeout(r);
        }, 300);
      }

      if (serverPackageList.length) {
        updateProgress();
      } else {
        if (package_s.length) {
          timeout = setTimeout(function() {
            checkAppState(package_s[0]);
          }, 3000);
        }
      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });

  // timeout = setTimeout(function() {
  //   checkAppState(package_s[0]);
  // }, 3000);
};

function disableBtn(s){
  if (s) {
    jQuery('.jvc-sjztbtn').addClass('disable-btn');
  }else {
    jQuery('.jvc-sjztbtn').removeClass('disable-btn');
  }
}

function errmsgTip(errinfo) {
  var text = UNAS._(errinfo);
  var _uninstallWindow = new MUI.Modal({
    id: 'errmsgWindowConfirm',
    title: UNAS._('Tips'),
    contentURL: '/apps/systemupgrade/errmsg.html?v=6.0.73&text=' + text,
    modal: true,
    modalOverlayClose: false,
    width: 500,
    height: 200
  });
  _uninstallWindow.callBack = function() {

  };
}

Array.prototype.remove = function(value) {
  var len = this.length;
  for (var i = 0, n = 0; i < len; i++) { //把出了要删除的元素赋值给新数组
    if (this[i] != value) {
      this[n++] = this[i];
    } else {}
  }
  this.length = n;
};
