
var recordsList = [];
function refreshRecords(result){
  let records = [];
  let lang = UNAS.CurrentLanguage || 'english';
  if (result) {
    if (UNAS.CurrentLanguage == '' || UNAS.CurrentLanguage == null) {
      lang = 'records';
    }
    if (UNAS.CurrentLanguage == 'English') {
      lang = 'english';
    }
    if (UNAS.CurrentLanguage == '简体中文') {
      lang = 'zh-cn';
    }
    for (var variable in result.results) {
      if (result.results.hasOwnProperty(variable)) {
        if (variable == lang) {
          lang = variable;
          isLang = 0;
        }
      }
    }
    if (result.results) {
      records = result.results[lang];
    }
  }

  let contentH = 0;
  if (records.length) {
    jQuery('#jv-recordshost').empty();
    // records = records.concat(recordsarr);
    // console.log(records);
    for (let i = 0; i < records.length; i++) {
      const tem = records[i];
      let recordsDom = wfTemplateAppend('#jv-recordshost', 'jvt-record', 'jvt-record' + i);
      recordsDom.find('.jvc-released').text(tem.released);
      recordsDom.find('.jvc-date').text(tem.date);
      if (i == 0) {
        recordsDom.addClass('d1');
        recordsDom.find('.timeline-icon img').attr('src', '/apps/systemupgrade/images/icon_spot01.png?v=6.0.69&');
      }else {
        recordsDom.addClass('d2');
        recordsDom.find('.timeline-icon img').attr('src', '/apps/systemupgrade/images/icon_spot02.png?v=6.0.69&');
      }

      for (var j = 0; j < tem.changes.length; j++) {
        const changesInfo = tem.changes[j];
        let changesDom = wfTemplateAppend(recordsDom.find('.jvc-changes-host'), 'jvt-changesItem', 'jvt-changesItem' + i + j);
        changesDom.find('.appname').text(changesInfo.app);
        var p = ''
        for (var k = 0; k < changesInfo.changed.length; k++) {
          p += '<p>- '+changesInfo.changed[k]+'</p>';
        }
          changesDom.find('.changedTxt').html(p);
      }

    }

  }
}

function getRecords() {
  let host = window.location.host;
  let data = {
    cmd: 'upgrade_changelog',
    token: UToken,
    params: []
  }
  jQuery.ajax({
    //url: '/apps/systemupgrade/includes/index.php', //接口
    url: '/wmi/',
    type: 'post', //GET或POST
    data: JSON.stringify(data),
    dataType: 'json',
    contentType: 'application/json',
    success: function(result) {
      recordsList = result;
      refreshRecords(result);
    },
    complete: function(event, xhr, options) {

    },
    error: function(xhr, textStatus) {

    }
  });
}

function wfTemplateAppend(target, template, name) {
  jQuery('#' + template).clone().attr('id', name).show().appendTo(target);
  var tagName = '#' + name;
  return jQuery(tagName);
}

jQuery(document).ready(function() {
  getRecords();
})
